///////////////////////////////////////////////////////////////////////////////////////
// 
// Kalman filter Process Noise models 
//  Reference: Labbe's Kalman Filter Book
///////////////////////////////////////////////////////////////////////////////////////

void calculateQ(){
  
if(qModel = 1){
  // Model 1. Modeling noise directly in accel terms only
  qMatrix(6,6) = pow(qAccSigma, 2.0);
  qMatrix(7,7) = pow(qAccSigma, 2.0);
  qMatrix(8,8) = pow(qAccSigma, 2.0);
}

if(qModel = 2){
  // Model 2. Power spectral noise model
  qMatrix(0,0) = (pow(_dt,5.0)) / 20.0;
  qMatrix(0,3) = (pow(_dt,4.0)) / 8.0;
  qMatrix(0,6) = (pow(_dt,3.0)) / 6.0;
  qMatrix(3,0) = (pow(_dt,4.0)) / 8.0;
  qMatrix(3,3) = (pow(_dt,3.0)) / 3.0;
  qMatrix(3,6) = (pow(_dt,2.0)) / 2.0;
  qMatrix(6,0) = (pow(_dt,3.0)) / 6.0;
  qMatrix(6,3) = (pow(_dt,2.0)) / 2.0;
  qMatrix(6,6) = _dt; 

  qMatrix(1,1) = (pow(_dt,5.0)) / 20.0;
  qMatrix(1,4) = (pow(_dt,4.0)) / 8.0;
  qMatrix(1,7) = (pow(_dt,3.0)) / 6.0;
  qMatrix(4,1) = (pow(_dt,4.0)) / 8.0;
  qMatrix(4,4) = (pow(_dt,3.0)) / 3.0;
  qMatrix(4,7) = (pow(_dt,2.0)) / 2.0;
  qMatrix(7,1) = (pow(_dt,3.0)) / 6.0;
  qMatrix(7,4) = (pow(_dt,2.0)) / 2.0;
  qMatrix(7,7) = _dt; 

  qMatrix(2,2) = (pow(_dt,5.0)) / 20.0;
  qMatrix(2,5) = (pow(_dt,4.0)) / 8.0;
  qMatrix(2,8) = (pow(_dt,3.0)) / 6.0;
  qMatrix(5,2) = (pow(_dt,4.0)) / 8.0;
  qMatrix(5,5) = (pow(_dt,3.0)) / 3.0;
  qMatrix(5,8) = (pow(_dt,2.0)) / 2.0;
  qMatrix(8,2) = (pow(_dt,3.0)) / 6.0;
  qMatrix(8,5) = (pow(_dt,2.0)) / 2.0;
  qMatrix(8,8) = _dt; 

  // Multiply by power spectral density
  qMatrix = qMatrix * qAccPwrSpecDensity;
}

if(qModel = 3){
  // Model 3. Jerk noise model
  qMatrix(0,0) = (pow(_dt,4.0)) / 4.0;
  qMatrix(0,3) = (pow(_dt,3.0)) / 2.0;
  qMatrix(0,6) = (pow(_dt,2.0)) / 2.0;
  qMatrix(3,0) = (pow(_dt,3.0)) / 2.0;
  qMatrix(3,3) = (pow(_dt,2.0));
  qMatrix(3,6) = _dt;
  qMatrix(6,0) = (pow(_dt,2.0)) / 2.0;
  qMatrix(6,3) = _dt;
  qMatrix(6,6) = 1.0; 

  qMatrix(1,1) = (pow(_dt,4.0)) / 4.0;
  qMatrix(1,4) = (pow(_dt,3.0)) / 2.0;
  qMatrix(1,7) = (pow(_dt,2.0)) / 2.0;
  qMatrix(4,1) = (pow(_dt,3.0)) / 2.0;
  qMatrix(4,4) = (pow(_dt,2.0));
  qMatrix(4,7) = _dt;
  qMatrix(7,1) = (pow(_dt,2.0)) / 2.0;
  qMatrix(7,4) = _dt;
  qMatrix(7,7) = 1.0; 

  qMatrix(2,2) = (pow(_dt,4.0)) / 4.0;
  qMatrix(2,5) = (pow(_dt,3.0)) / 2.0;
  qMatrix(2,8) = (pow(_dt,2.0)) / 2.0;
  qMatrix(5,2) = (pow(_dt,3.0)) / 2.0;
  qMatrix(5,5) = (pow(_dt,2.0));
  qMatrix(5,8) = _dt;
  qMatrix(8,2) = (pow(_dt,2.0)) / 2.0;
  qMatrix(8,5) = _dt;
  qMatrix(8,8) = 1.0; 

  // Multiply by jerk variance
  qMatrix = qMatrix * pow(qJerkSigma,2.0);
}

} // end void

