///////////////////////////////////////////////////////////////////////////////////////
// 
// Serial Port Processing
///////////////////////////////////////////////////////////////////////////////////////

void serialPortOutKF(){
  
  // Set textLength to the number of parameters to print * 31
  int  textLength = 10 * 31;
  char text[textLength];
  
  // KF parameters
  char utcTimeText[30];
  char latText[30]; 
  char lonText[30]; 
  char altText[30]; 
  char pk1xText[30]; 
  char pk1yText[30]; 
  char pk1zText[30]; 
  char nuk1xText[30]; 
  char nuk1yText[30]; 
  char nuk1zText[30]; 
  
  rtk.upDated = false;

Dtime( 10, 0, 0 );
  dtostrf(utcTime, 10, 8, utcTimeText);
  dtostrf(RefLLA(0,0)*rad2deg, 10, 8, latText);
  dtostrf(RefLLA(1,0)*rad2deg, 10, 8, lonText);
  dtostrf(RefLLA(2,0), 10, 4, altText);
  dtostrf(sqrt(pk1(0,0)), 10, 4, pk1xText);
  readGPS();; 
  dtostrf(sqrt(pk1(1,1)), 10, 4, pk1yText);
  dtostrf(sqrt(pk1(2,2)), 10, 4, pk1zText);
  dtostrf(nuk1(0,0), 10, 4, nuk1xText);
  dtostrf(nuk1(1,0), 10, 4, nuk1yText);
  dtostrf(nuk1(2,0), 10, 4, nuk1zText);
Dtime( 10, 1, "dtos_OutKF" );


  readGPS();; 

  rtk.upDated = false;

  // Create single text parameter and print it
  snprintf(text, textLength, "%s,%s,%s,%s,%s,%s,%s,%s,%s,%s",
           utcTimeText,
           latText, lonText, altText,
           pk1xText, pk1yText, pk1zText,
           nuk1xText, nuk1yText, nuk1zText);
  readGPS();; 
  cout.println(text);         
}    

///////////////////////////////////////////////////////////////////////////////////////
// 
// Serial Port Processing
///////////////////////////////////////////////////////////////////////////////////////

elapsedMicros TVt;
elapsedMillis TVsec;
uint32_t AHz = 0, AC0 = 0, AC1=0, AC2=0, AC3=1000001; 

void serialDataOut()
{
  #ifdef coutD
    if ( TVsec >= 1000 ) {
      coutD.print( "\n | AC1 tos=");
      coutD.print( AC1 );
      coutD.print( "\t | AC2 tpf=");
      coutD.print( AC2 );
      coutD.print( "\t | AC3 Hz=");
      coutD.println( AC3 );
      if ( AC3 > 1000000 )
        TVsec = 0;
      else
        TVsec -= 1000;
      AC0 = AC1 = AC2 = AC3 = 0;
    }
    AC3++;
    TVt = 0;
  #endif

  rtk.upDated = false;

  cout.printf("%10.6f, %10.6f, %10.6f, %8.6f, %d",
           timeStamp*0.001, rtk.utcTime, IMU_RX_time*0.000001f,
           _dt, rtk.fixType);
  cout.printf("%12.8lf,%12.8lf,%10.4f", rtk.lat1, rtk.lon1, rtk.hMSL);
  cout.printf("%10.4f,%10.4f,%10.4f", rtk.velN, rtk.velE, rtk.velD);
  cout.printf("%10.4f,%10.4f,%10.4f", ypr[1], ypr[2], ypr[0]);
  cout.printf("%10.4f,%10.4f,%10.4f\n",aNEDx1, aNEDy1, aNEDz1);
  
  AC1 += TVt;
  TVt = 0;
  AC2 += TVt;
}


void serialPortOut(){  
  // Set textLength to the number of parameters to print * 31
  int  textLength = 16 * 31;
  char text[textLength];
  
  //Temporary text parameters
  char acc_xText[30];
  char acc_yText[30];
  char acc_zText[30];
  char accNED_xText[30];
  char accNED_yText[30];
  char accNED_zText[30];
  char dtText[30];
  
  char utcText[30];
  char fixTypeText[30];
  char latText[30];
  char lonText[30];
  char altText[30];
  char velNText[30];
  char velEText[30];
  char velDText[30];
  
  char pitchText[30];
  char rollText[30];
  char yawText[30];
  char tS_Text[30];

#ifdef coutD
  if ( TVsec >= 1000 ) {
    coutD.print( " AC0 tos=");
    coutD.print( AC0 );
    coutD.print( "\t | AC1 tsp=");
    coutD.print( AC1 );
    coutD.print( "\t | AC2 tpl=");
    coutD.print( AC2 );
    coutD.print( "\t | AC3 tso=");
    coutD.print( AC3 );
    coutD.print( "\t | AHz =");
    coutD.println( AHz );
    AC0 = AC1 = AC2 = AC3 = AHz = 0;
    TVsec = 0;
  }
  AHz++;

  TVt = 0;
#endif

  dtostrf(timeStamp*0.001,10,6, tS_Text);          
  dtostrf(utcTime, 10, 10, utcText);
  dtostrf(_dt, 10, 10, dtText);
  
  dtostrf(uBloxData.fixType, 10, 7, fixTypeText);
  dtostrf(uBloxData.lat, 10, 7, latText);
  dtostrf(uBloxData.lon, 10, 7, lonText);
  dtostrf(uBloxData.height, 10, 7, altText);
  dtostrf(uBloxData.velN, 10, 4, velNText);
  dtostrf(uBloxData.velE, 10, 4, velEText);
  dtostrf(uBloxData.velD, 10, 4, velDText);

  dtostrf(ypr[1], 10, 4, pitchText);
  dtostrf(ypr[2], 10, 4, rollText);
  dtostrf(ypr[0], 10, 4, yawText);

  dtostrf(aNEDx1, 10, 4, accNED_xText);
  dtostrf(aNEDy1, 10, 4, accNED_yText);
  dtostrf(aNEDz1, 10, 4, accNED_zText);

  AC0 += TVt;  // double to string time
  TVt = 0;

  rtk.upDated = false;

  // Create single text parameter and print it
  snprintf(text, textLength, "%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s",
           tS_Text, utcText, dtText, fixTypeText,
           latText, lonText, altText,
           velNText, velEText, velDText,
           pitchText, rollText, yawText,
           accNED_xText, accNED_yText, accNED_zText);

  //snprintf(text, textLength, "%10.6f,%10.6f,%10.6f,%10.6f,%10.6f,%10.6f,%10.6f,%10.6f,%10.6f,%10.6f,%10.6f,%10.6f,%10.6f,%10.6f,%10.6f",
  //         timeStamp*0.001, rtk.utcTime,
  //         _dt, rtk.fixType,rtk.lat1, rtk.lon1, rtk.hMSL,
  //         rtk.velN, rtk.velE, rtk.velD,
  //         ypr[1], ypr[2], ypr[0],
  //         aNEDx1, aNEDy1, aNEDz1);
  AC1 += TVt;  // time to convert to text string
  TVt = 0;
  cout.println(text);  
  AC2 += TVt;  //time to print to port
  TVt = 0;
  cout.send_now();
  AC3 += TVt;  //send_now flush time
}    
 

